final: final-py: prev-py: {
  mne-python = prev-py.mne-python.overridePythonAttrs (old: {
    pyproject = true;
    format = null;
    propagatedBuildInputs = old.propagatedBuildInputs ++ [
      final-py.setuptools-scm
    ];
  });

  edfio = let
    version = "0.4.1";
    pname = "edfio";
  in final-py.buildPythonPackage {
    inherit pname version;
    format = "pyproject";
    
    src = final.fetchFromGitHub {
      owner = "the-siesta-group";
      repo = pname;
      rev = "v${version}";
      hash = "sha256-+yb3Q/JximkVS6SOTFnjMYghbOi+UBbqW2Bs29eSonA=";
    };

    nativeBuildInputs = with final-py; [
      poetry-core
      poetry-dynamic-versioning
    ];
    
    propagatedBuildInputs = with final-py; [
      numpy
    ];
  };

  importRosbag = final-py.buildPythonPackage {
    pname = "importRosbag";
    version = "1.0.4.1";
    
    src = final.fetchFromGitHub {
      owner = "event-driven-robotics";
      repo = "importRosbag";
      rev = "71183fe375ec0f79512100db16c1a955b7aadf62";
      hash = "sha256-2ey+IGKqkvvHhEneoZlSx1g074/WKpWKZED04BVXkaM=";
    };

    propagatedBuildInputs = with final-py; [
      tqdm
      numpy
    ];
  };
  
  expelliarmus = final-py.buildPythonPackage {
    pname = "expelliarmus";
    version = "14-03-23";
    
    src = final.fetchFromGitHub {
      owner = "open-neuromorphic";
      repo = "expelliarmus";
      rev = "6ed9e41e4d289b45d5e2ca2526cff4ea276f3494";
      hash = "sha256-glW0W6OjTpWu+DKtGHBaJXBm7XMZSQYEaC2DjghQFho=";
    };

    buildInputs = with final-py; [
      pytest
    ];

    propagatedBuildInputs = with final-py; [
      numpy
    ];
  };
  
  pytorch-data = final-py.buildPythonPackage rec {
    pname = "pytorch-data";
    version = "0.7.1";

    src = final.fetchFromGitHub {
      owner = "pytorch";
      repo = "data";
      rev = "v${version}";
      hash = "sha256-yF3WHVOP1BIhGpitkQDy8dry4ZnEOh4+U6XTaG7mBv4=";
      fetchSubmodules = true;
    };

    doCheck = false;

    nativeBuildInputs = with final; [
      cmake
    ];

    dontUseCmakeConfigure = true;
    
    buildInputs = with final; [
      git
    ];

    propagatedBuildInputs = with final-py; [
      urllib3
      requests
      torch
    ];
  };

  tonic = final-py.buildPythonPackage rec {
    pname = "tonic";
    version = "1.5.0";
    env.PBR_VERSION = version;
    src = final.fetchFromGitHub {
      owner = "neuromorphs";
      repo = "tonic";
      rev = "v${version}";
      hash = "sha256-edwd/iJpwBXGw7CB7bD/ZVW/47pwrTOzD2lX5ULHiMY=";
    };

    propagatedBuildInputs = with final-py; [
      numpy
      h5py
      importRosbag
      scipy
      tqdm
      librosa
      pbr
      expelliarmus
      typing-extensions
      # Technically not required
      torch
      torchaudio
      pytorch-data
    ];
  };
} // (import ./spynnaker.nix final final-py prev-py)
